Attribute VB_Name = "mdlRegistry"
Option Explicit

Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long

Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long

Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long

Private Const ERROR_SUCCESS = 0&

Private Const SYNCHRONIZE = &H100000
Private Const READ_CONTROL = &H20000
Private Const STANDARD_RIGHTS_READ = (READ_CONTROL)
Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_SET_VALUE = &H2
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_CREATE_LINK = &H20
'Private Const STANDARD_RIGHTS_WRITE = (READ_CONTROL)
'Private Const KEY_WRITE = ((STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY) And (Not SYNCHRONIZE))
Private Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
'Private Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))

'񋓑΂ɂĂ܂
'WXg̃L[
Public Enum EnumRegKeyType
    HKEY_CLASSES_ROOT = &H80000000
    HKEY_CURRENT_USER = &H80000001
    HKEY_LOCAL_MACHINE = &H80000002
    HKEY_USERS = &H80000003
    HKEY_PERFORMANCE_DATA = &H80000004
    HKEY_CURRENT_CONFIG = &H80000005
    HKEY_DYN_DATA = &H80000006
End Enum

'WXg̒l̎
Private Const REG_SZ = 1
Private Const REG_DWORD = 4

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
' @  \F Chr$(0)[=vbNullChar] ܂Ŏ擾
'   F(in)SrcStr c Ώە
' ԂlFҏWꂽ
'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Public Function StrNullCut(ByVal SrcStr As String) As String
    Dim NullCharPos As Integer
    NullCharPos = InStr(SrcStr, Chr$(0))
    If NullCharPos = 0 Then
        StrNullCut = SrcStr
        Exit Function
    End If
    StrNullCut = Left$(SrcStr, NullCharPos - 1)
End Function

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
' @  \FWXgl擾
'   F(i)RegKeyType  c WXg̃L[(`g)
'         (i)RegRoot     c `gȉ̃pX
'         (i)RegName     c 擾l̃L[(vbNullStringw肳ꂽꍇ́u(W)vL[ƂȂ)
'         (i)IsRegValStr c 擾l̏ꍇTrueAl̏ꍇFalse
'         (o)RegValue    c 擾l(l̏ꍇ͕񉻂(Ԕ))
' ԂlFcTrue  ُcFalse
'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Public Function GetRegValue(ByVal RegKeyType As EnumRegKeyType, ByVal RegRoot As String, ByVal RegName As String, ByVal IsRegValStr As Boolean, ByRef RegValue As String) As Boolean
    Dim hRegKey As Long
    Dim FuncRet As Long
    
    'WXgJ
    FuncRet = RegOpenKeyEx(RegKeyType, RegRoot, 0&, KEY_READ, hRegKey)
    If FuncRet <> ERROR_SUCCESS Then Exit Function
    
    '擾
    If IsRegValStr Then
        Dim RegStrBuffer As String * 256
        FuncRet = RegQueryValueEx(hRegKey, RegName, 0&, REG_SZ, ByVal RegStrBuffer, Len(RegStrBuffer))
        If FuncRet = ERROR_SUCCESS Then
            RegValue = StrNullCut(RegStrBuffer)
        End If
    'l擾
    Else
        Dim RegLngBuffer As Long
        FuncRet = RegQueryValueEx(hRegKey, RegName, 0&, REG_DWORD, RegLngBuffer, Len(RegStrBuffer))
        If FuncRet = ERROR_SUCCESS Then
            RegValue = CStr(RegLngBuffer)
        End If
    End If

    GetRegValue = (FuncRet = ERROR_SUCCESS)
End Function


